/*

 * @(#)Courbe.java	6/12/2000

 *

 */



import java.awt.*;

import java.awt.event.*;

import java.applet.*;

import java.io.*;





/**

 * Trac de courbe paramtre

 * peut tre lance soit comme une Applet, 

 * soit comme une application indpendante

 */



public class Courbe extends Applet implements ActionListener,ItemListener{

   TextField tMinText,tMaxText,tNbText,xText,yText,zoomText,aMinText,aMaxText,aNbText;

   Button paramButton,polarButton,developButton,podaireButton;

   CourbeCanvas c;

   Checkbox grilleCheckbox;

   double zoom=1;

   

    private void initChampsT(){

    	// champs t

		add(new Label("min de t="),"0,0,,,,,");

		tMinText=new TextField((new Double(-3)).toString(),6);

		add(tMinText,"1,0,,,,,");

		add(new Label("max de t="),"2,0,,,,,");

		tMaxText=new TextField((new Double(3)).toString(),6);

		add(tMaxText,"3,0,,,,,");

		add(new Label("nb de points="),"4,0,,,,,");

		tNbText=new TextField((new Integer(1000)).toString(),4);

		add(tNbText,"5,0,,,,,");

    }

    

    private void initChampsXY(){

	    // champs x,y

		add(new Label("x (ou rho)= "),"0,1,,,,,");

		xText=new TextField("sin(2*t)",20);

		add(xText,"1,1,3,,,,");

		add(new Label("y (ou theta)= "),"4,1,,,,,");

		yText=new TextField("cos(3*t)",20);

		add(yText,"5,1,3,,,,");

    }

   	

   	private void initAutresChamps(){

   		// autres champs

		add(new Label("zoom="),"0,2,,,,,");

		zoomText=new TextField((new Double(1)).toString(),4);

		add(zoomText,"1,2,,,,,");

		add(new Label("min de a="),"2,2,,,,,");

		aMinText=new TextField((new Double(0)).toString(),6);

		add(aMinText,"3,2,,,,,");

		add(new Label("max de a="),"4,2,,,,,");

		aMaxText=new TextField((new Double(0)).toString(),6);

		add(aMaxText,"5,2,,,,,");

		add(new Label("nb de courbes="),"6,2,,,,,");

		aNbText=new TextField((new Integer(1)).toString(),3);

		add(aNbText,"7,2,,,,,");

   	}

   	

   	private void initBoutons(){

	   	// boutons de trac

		paramButton=new Button("parametrique");

		add(paramButton,"0,3,,,,,");

		paramButton.addActionListener(this);

		polarButton=new Button("polaire");

		add(polarButton,"1,3,,,,,");

		polarButton.addActionListener(this);

		developButton=new Button("developpee (param)");

		add(developButton,"2,3,2,,,,");

		developButton.addActionListener(this);

		podaireButton=new Button("podaire (param)");

		add(podaireButton,"4,3,2,,,,");

		podaireButton.addActionListener(this);

		grilleCheckbox = new Checkbox("grille");

	    add(grilleCheckbox,"6,3,,,,,");

		grilleCheckbox.addItemListener(this);

	}

	

	private void initCourbe(){

		// et la courbe

		add(KappaLayout.createVerticalStrut(400),"0 , 4 , , , , , ");

		c = new CourbeCanvas(-3,3,1000,0,0,1,"sin(2*t)","cos(3*t)",1);

		add(c,"1,4,6,,,hw,");

	}

   

    public void init() {

		setLayout(new KappaLayout());

		initChampsT();

		initChampsXY();

		initAutresChamps();

		initBoutons();

		initCourbe();

	}

    



    public void actionPerformed(ActionEvent e) {

		int tNb,aNb;

		double tMin,tMax,aMin,aMax;

		

		if(e.getSource() instanceof Button) {

			try {

				tNb=Integer.parseInt(tNbText.getText());

				tMin=(Double.valueOf(tMinText.getText())).doubleValue();

				tMax=(Double.valueOf(tMaxText.getText())).doubleValue();

				aNb=Integer.parseInt(aNbText.getText());

				aMin=(Double.valueOf(aMinText.getText())).doubleValue();

				aMax=(Double.valueOf(aMaxText.getText())).doubleValue();

				zoom=(Double.valueOf(zoomText.getText())).doubleValue();

			}

			catch(NumberFormatException erreur) {

				tMin=-3;

				tMax=3;

				tNb=200;

				aMin=0;

				aMax=0;

				aNb=1;

				zoom=1;

			}

			if(e.getSource()==paramButton) 

				c.traceCourbe(tMin,tMax,tNb,aMin,aMax,aNb,xText.getText(),yText.getText(),zoom,CourbeCanvas.PARAM);

		    if(e.getSource()==polarButton) 

				c.traceCourbe(tMin,tMax,tNb,aMin,aMax,aNb,xText.getText(),yText.getText(),zoom,CourbeCanvas.POLAR);

			if(e.getSource()==developButton)

				c.traceCourbe(tMin,tMax,tNb,aMin,aMax,aNb,xText.getText(),yText.getText(),zoom,CourbeCanvas.DEVELOP);

			if(e.getSource()==podaireButton)

				c.traceCourbe(tMin,tMax,tNb,aMin,aMax,aNb,xText.getText(),yText.getText(),zoom,CourbeCanvas.PODAIRE);

		}

    }

    

	public void itemStateChanged(ItemEvent e) {

                        if(e.getItemSelectable() == grilleCheckbox){

                                c.changeGrille();

                        }

	}

	

    

    public static void main(String args[]) {

	Frame f = new Frame("Ma courbe");

	Courbe	courbe = new Courbe();



	courbe.init();

	courbe.start();



	f.add("Center", courbe);

	f.setSize(300, 300);

	f.show();

    }

}

    



class CourbeCanvas extends Canvas {

	public static final int PARAM=0, POLAR=1, DEVELOP=2,PODAIRE=3,CONCHOID=4;

    int		maxHor = 300;

    int		maxVer = 300;

	int nombrePoints,nombreCourbes=1;

	double xMin = -3;

	double xMax= 3;

	double yMin= -3;

	double yMax=3;

	double aMin=0, aMax=0;

	double tDebut,tFin;

	boolean grille=false;

	String fctX,fctY;

	Analyseur anal=new Analyseur();

	int type=PARAM;

	

	

	

	CourbeCanvas(double tMin, double tMax,int Nb, double aMin, double aMax, int aNb,String x,String y,double zoom) {

		super();

		tDebut=tMin;

		tFin=tMax;

		nombrePoints=Nb;

		this.aMin=aMin;

		this.aMax=aMax;

		nombreCourbes=aNb;

		xMin=-3/zoom;

		xMax=-xMin;

		yMin=-3/zoom;

		yMax=-yMin;

		fctX=x;

		fctY=y;

	}

	

	void changeGrille() {

		grille=!grille;

		repaint();

	}

	

	void traceCourbe(double tMin, double tMax,int Nb, double aMin, double aMax, int aNb,String x,String y,double zoom,int type) {

		tDebut=tMin;

		tFin=tMax;

		nombrePoints=Nb;

		this.aMin=aMin;

		this.aMax=aMax;

		nombreCourbes=aNb;

		xMin=-3/zoom;

		xMax=-xMin;

		yMin=-3/zoom;

		yMax=-yMin;

		fctX=x;

		fctY=y;

		this.type=type;

		repaint();

	}

	

	int xEcran(double x,double xDebut,double xFin) {

		return (int) ((x-xDebut)/(xFin-xDebut)*maxHor);

	}

	

	int yEcran(double y,double yDebut,double yFin) {

		return (int) ((yFin-y)/(yFin-yDebut)*maxVer);

	}

	

    

    public void paint(Graphics g){

		int x1,y1,x2,y2,k;

		double t,a,tPas,rho,theta,aPas;

		Expression xExpr=Expression.nouvelleExpression(0),yExpr=Expression.nouvelleExpression(0);

		Rectangle r = getBounds();

		

		maxVer = r.height;

		maxHor = r.width;

		// On trace les axes

		g.setColor(Color.blue);

		x1=xEcran(xMin,xMin,xMax);

		x2=xEcran(xMax,xMin,xMax);

		y1=yEcran(0,yMin,yMax);

		g.drawLine(x1,y1,x2,y1);

		x1=xEcran(0,xMin,xMax);

		y1=yEcran(yMin,yMin,yMax);

		y2=yEcran(yMax,yMin,yMax);

		g.drawLine(x1,y1,x1,y2);

		

		// on trace la grille

		if(grille) {

			g.setColor(Color.green);

			for(int i=(int)Math.ceil(xMin);i<=(int)Math.floor(xMax);i++) {

				if(i!=0) {

					x1=xEcran(i,xMin,xMax);

					y1=yEcran(yMin,yMin,yMax);

					y2=yEcran(yMax,yMin,yMax);

					g.drawLine(x1,y1,x1,y2);

				}

			}

			for(int i=(int)Math.ceil(yMin);i<=(int)Math.floor(yMax);i++) {

				if(i!=0) {

					x1=xEcran(xMin,xMin,xMax);

					x2=xEcran(xMax,xMin,xMax);

					y1=yEcran(i,yMin,yMax);

					g.drawLine(x1,y1,x2,y1);

				}

			}

		}

		

		// On tablit les paramtres

		g.setColor(Color.red);

		tPas=(tFin-tDebut)/nombrePoints;

		aPas= nombreCourbes>1 ? (aMax-aMin)/(nombreCourbes-1) : 0;

		try {

				xExpr=anal.analyse(fctX); // System.out.println(xExpr);

				yExpr=anal.analyse(fctY); // System.out.println(yExpr);

		} catch (IOException e) {

				System.err.print("Syntaxe incorrecte");

				System.exit(1);

		}

		// On trace la courbe

		switch(type) {

			case POLAR: 

				for(k=1,a=aMin; k<=nombreCourbes;k++,a+=aPas) {

					t=tDebut;

					rho=xExpr.evalue("t",t,"a",a);

					theta=yExpr.evalue("t",t,"a",a);

					x1=xEcran(rho*Math.cos(theta),xMin,xMax);

					y1=yEcran(rho*Math.sin(theta),yMin,yMax);

					for(int i=0;i<=nombrePoints;i++) {

						t+=tPas;

						rho=xExpr.evalue("t",t,"a",a);

						theta=yExpr.evalue("t",t,"a",a);

						x2=xEcran(rho*Math.cos(theta),xMin,xMax);

						y2=yEcran(rho*Math.sin(theta),yMin,yMax);

						g.drawLine(x1,y1,x2,y2);

						x1=x2;

						y1=y2;

					}

				}

				break;

		 case PARAM:

				for(k=1,a=aMin; k<=nombreCourbes;k++,a+=aPas) {

					t=tDebut;

					x1=xEcran(xExpr.evalue("t",t,"a",a),xMin,xMax);

					y1=yEcran(yExpr.evalue("t",t,"a",a),yMin,yMax);

					for(int i=0;i<=nombrePoints;i++) {

						t+=tPas;

						x2=xEcran(xExpr.evalue("t",t,"a",a),xMin,xMax);

						y2=yEcran(yExpr.evalue("t",t,"a",a),yMin,yMax);

						g.drawLine(x1,y1,x2,y2);

						x1=x2;

						y1=y2;

					}

				}

				break;

		case DEVELOP:

				for(k=1,a=aMin; k<=nombreCourbes;k++,a+=aPas) {

					t=tDebut;

					double x0=xExpr.evalue("t",t,"a",a);

					double y0=yExpr.evalue("t",t,"a",a);

					double x0prime=xExpr.evalueDer("t",t,"a",a);

					double y0prime=yExpr.evalueDer("t",t,"a",a);

					double x0sec=xExpr.evalueDer2("t",t,"a",a);

					double y0sec=yExpr.evalueDer2("t",t,"a",a);

					double lambda= (x0prime*x0prime+y0prime*y0prime)/(x0prime*y0sec-x0sec*y0prime);

					double xi = x0 - lambda*y0prime;

					double eta = y0 + lambda*x0prime;

					x1=xEcran(xi,xMin,xMax);

					y1=yEcran(eta,yMin,yMax);

					for(int i=0;i<=nombrePoints;i++) {

						t+=tPas;

					    x0=xExpr.evalue("t",t,"a",a);

					    y0=yExpr.evalue("t",t,"a",a);

					    x0prime=xExpr.evalueDer("t",t,"a",a);

					    y0prime=yExpr.evalueDer("t",t,"a",a);

					    x0sec=xExpr.evalueDer2("t",t,"a",a);

					    y0sec=yExpr.evalueDer2("t",t,"a",a);

					    lambda= (x0prime*x0prime+y0prime*y0prime)/(x0prime*y0sec-x0sec*y0prime);

					    xi = x0 - lambda*y0prime;

					    eta = y0 + lambda*x0prime;

						x2=xEcran(xi,xMin,xMax);

						y2=yEcran(eta,yMin,yMax);

						g.drawLine(x1,y1,x2,y2);

						x1=x2;

						y1=y2;

					}

				}

				break;

		case PODAIRE:

				for(k=1,a=aMin; k<=nombreCourbes;k++,a+=aPas) {

					t=tDebut;

					double x0=xExpr.evalue("t",t,"a",a);

					double y0=yExpr.evalue("t",t,"a",a);

					double x0prime=xExpr.evalueDer("t",t,"a",a);

					double y0prime=yExpr.evalueDer("t",t,"a",a);

				    double lambda= (x0*y0prime-x0prime*y0)/(x0prime*x0prime+y0prime*y0prime);

					double xi = lambda*y0prime;

					double eta = - lambda*x0prime;

					x1=xEcran(xi,xMin,xMax);

					y1=yEcran(eta,yMin,yMax);

					for(int i=0;i<=nombrePoints;i++) {

						t+=tPas;

					    x0=xExpr.evalue("t",t,"a",a);

					    y0=yExpr.evalue("t",t,"a",a);

					    x0prime=xExpr.evalueDer("t",t,"a",a);

					    y0prime=yExpr.evalueDer("t",t,"a",a);

					    lambda= (x0*y0prime-x0prime*y0)/(x0prime*x0prime+y0prime*y0prime);

					    xi =  lambda*y0prime;

					    eta = -lambda*x0prime;

						x2=xEcran(xi,xMin,xMax);

						y2=yEcran(eta,yMin,yMax);

						g.drawLine(x1,y1,x2,y2);

						x1=x2;

						y1=y2;

					}

				}

				break;

		}

		

				

    }

    

}



