import java.io.*;
import java.util.*;
import java.awt.*;

class Construction implements Serializable{
      String nom;
      Vector objets;
      int nombreObjets=0;
      static RCFrame fenetre;
      static RCCanvas tableau;
      
      public static final int
	          NON_CONCERNE = 0, INITIAL = 1, INTERMEDIAIRE = 2, FINAL = 3;
      
      private class ConstrObjet implements Serializable{
          int numero, type, statut, pere1, pere2, constr;
          
          ConstrObjet(int numero, GeomObject obj){
              this.numero = numero;
              type = obj.type;
              statut = obj.statutConstruction;
              constr = obj.constr;
              if(obj.pere1!=null) pere1 = obj.pere1.numero;
              else pere1 = -1;
              if(obj.pere2!=null) pere2 = obj.pere2.numero;
              else pere2 = -1;
           }
      }
      
      private class ConstrException extends Exception{
      }
        
      
      Construction(String s){
          nom = s;
          nombreObjets = 0;
          objets = new Vector();
      }
      
      private void metAZero(){
           GeomObject obj = tableau.premier;
           while(obj!=null){
              obj.statutConstruction=NON_CONCERNE;
              obj=obj.suivant;
           }
      }
      
      public void ajouter(GeomObject obj){
          objets.addElement(new ConstrObjet(nombreObjets++,obj));
      }
      
      private void definitInitiaux(){
          GeomObject obj;
          while(true){
             obj=fenetre.fournitObjet();
             if(obj==null) return;
             obj.statutConstruction = INITIAL;
          }
      }
      
      private void marque(GeomObject obj) throws ConstrException{
          if(obj.statutConstruction==INITIAL) return;
          if(obj.statutConstruction==NON_CONCERNE)
               obj.statutConstruction=INTERMEDIAIRE;
          if(obj.pere1!=null){
               marque(obj.pere1);
               if(obj.pere2!=null) marque(obj.pere2);
           } else throw new ConstrException();
      }
      
      private void definitFinaux() throws ConstrException{
          GeomObject obj;
          while(true){
             obj=fenetre.fournitObjet();
             if(obj==null) return;
             if(obj.statutConstruction==INITIAL) throw new ConstrException();
             obj.statutConstruction = FINAL;
             marque(obj);
          }           
      }
      
      private void numerote(){
          GeomObject obj=tableau.premier;
          int i=0;
	       while(obj!=null){
	          if(obj.statutConstruction!=NON_CONCERNE)
	              obj.numero = i++;
	           obj=obj.suivant;
	       }
      }
      
      private void stocke(){
          GeomObject obj=tableau.premier;
          int i=0;
          while(obj!=null){
	          if(obj.statutConstruction!=NON_CONCERNE)
	              objets.addElement(new ConstrObjet(i++,obj));
	           obj=obj.suivant;
	       }
      }
      
      public boolean definir(){
      	  metAZero();
      	  definitInitiaux();
      	  try{definitFinaux();}
      	  catch(ConstrException e){ return false; }
      	  numerote();
      	  stocke();
      	  return true;
      }
      
      public void interpreter(){
      	  Enumeration it = objets.elements();
      	  ConstrObjet obj;
      	  Vector lesObjets=new Vector();
      	  GeomObject gObj;
      	  while(it.hasMoreElements()){ 
      	       obj=(ConstrObjet) it.nextElement();
      	       switch(obj.statut){
      	          case INITIAL:
      	             switch(obj.type){
      	                 case Geom.POINT : 
      	                    lesObjets.addElement(fenetre.fournitPoint());
      	                    break;
      	                 case Geom.DROITE : 
      	                    lesObjets.addElement(fenetre.fournitDroite());
      	                    break;
      	                 case Geom.CERCLE : 
      	                    lesObjets.addElement(fenetre.fournitCercle());
      	                    break;
      	              }
      	              break;
      	           case INTERMEDIAIRE:
      	                  gObj = GeomObject.newObjet(obj.constr,
      	                          obj.pere1==-1? null : (GeomObject) lesObjets.elementAt(obj.pere1),
      	                          obj.pere2==-1? null : (GeomObject) lesObjets.elementAt(obj.pere2));
      	                  lesObjets.addElement(gObj);
      	                  gObj.couleur=Color.white; // invisible
      	                  tableau.insereAvecCouleur(gObj);
      	                  break;
      	           case FINAL: 
      	                  gObj = GeomObject.newObjet(obj.constr,
      	                          obj.pere1==-1? null : (GeomObject) lesObjets.elementAt(obj.pere1),
      	                          obj.pere2==-1? null : (GeomObject) lesObjets.elementAt(obj.pere2));
      	                  lesObjets.addElement(gObj);
      	                  tableau.insere(gObj);
      	                  break;
      	       }
      	    }
      }
      
}
      
      
      
      