import java.io.*;
import java.awt.*;

class GeomInputStream extends DataInputStream{
      Analyseur anal=new Analyseur();
      buf = new Vector();
        
      GeomInputStream(String s) throws IOException{
          super(new FileInputStream(s));
      }
      
      public String readString() throws IOException{
          return readUTF();
      }
      
      private GeomObject readGeom() throws IOException{
          int numero,type,constr,numPere1,numPere2,couleur;
          String nom;
      	  numero = readInt();
          type = readInt();
          constr = readInt();
          numPere1 = readInt();
          numPere2 = readInt();
          couleur = readInt();
          nom = readString();
          switch(type){
             case Geom.POINT: obj = readPoint(constr,numPere1,numPere2); break;
             case Geom.DROITE : obj = readDroite(constr,numPere1,numPere2); break;
             case Geom.CERCLE:  obj = readCercle(constr,numPere1,numPere2); break;
             case Geom.COURBE : obj = readCourbe(constr,numPere1,numPere2); break;
             case Geom.ENSEMBLE: obj = readEnsemble(constr,numPere1,numPere2); break;
          }
          obj.numero = numero;
          obj.couleur = new Color(couleur);
          obj.nom = nom;
          return obj;
      }
      
      public GPoint readGPoint(int constr,int numPere1,int numPere2) throws IOException{
          double x,y;
          x=readDouble();
          y=readDouble();
          switch(constr){
             case Geom.LIBRE : 
                 return new GPoint(x,y); break;
             case Geom.LIE_DROITE : 
                 return newPointLieDroite(x,y,(GDroite) buf.elementAt(numPere1)); break;
             case Geom.LIE_CERCLE : 
                 return newPointLieCercle(x,y,(GCercle) buf.elementAt(numPere1)); break;
             case Geom.INTER2DROITES : 
                 return newIntersection((GDroite) buf.elementAt(numPere1),(GDroite) buf.elementAt(numPere2)); break;
             case Geom.MILIEU :
                 return newMilieu((GPoint) buf.elementAt(numPere1),(GPoint) buf.elementAt(numPere2)); break;
             case Geom.CENTRE_CERCLE :
                 return newCentreCercle((GCercle) buf.elementAt(numPere1)); break;
             case Geom.INTER_DROITE_CERCLE1 :
                 return newIntersection1((GDroite) buf.elementAt(numPere1),(GCercle) buf.elementAt(numPere2)); break;
			 case Geom.INTER_DROITE_CERCLE2 :
			     return newIntersection2((GDroite) buf.elementAt(numPere1),(GCercle) buf.elementAt(numPere2)); break;
			 case Geom.INTER2CERCLES1 :
			     return newIntersection1((GCercle) buf.elementAt(numPere1),(GCercle) buf.elementAt(numPere2)); break;
			 case Geom.INTER2CERCLES2 :
			     return newIntersection2((GCercle) buf.elementAt(numPere1),(GCercle) buf.elementAt(numPere2)); break;
			 case Geom.PROJECTION :
			     return newProjection((GPoint) buf.elementAt(numPere1),(GDroite) buf.elementAt(numPere2)); break;
	         case Geom.CENTRE_DE_COURBURE :
	             return newCentreDeCourbure((GCourbe) buf.elementAt(numPere1)); break;
	         case Geom.P_SYMETRIE_POINT:
	             return newSymetrique((GPoint) buf.elementAt(numPere1),(GPoint) buf.elementAt(numPere2)); break;
	         case Geom.P_SYMETRIE_DROITE:
	            return newSymetrique((GPoint) buf.elementAt(numPere1),(GDroite) buf.elementAt(numPere2)); break;
	         
	      }
	  }
          
      
      public GDroite readGDroite(int constr,int numPere1,int numPere2) throws IOException{
          double u,v,h;
          u = readDouble();
          v = readDouble();
          h = readDouble();
          switch(constr){
             case Geom.DROITE_PAR2POINTS : 
                 return newDroitePar2Points((GPoint) buf.elementAt(numPere1),(GPoint) buf.elementAt(numPere2)); break;
             case Geom.PARALLELE : 
                 return newParallele((GPoint) buf.elementAt(numPere1),(GDroite) buf.elementAt(numPere2)); break;
             case Geom.PERPENDICULAIRE : 
                 return newPerpendiculaire((GPoint) buf.elementAt(numPere1),(GDroite) buf.elementAt(numPere2)); break;
             case Geom.BISSECTRICE1 : 
                 return newBissectrice1((GDroite) buf.elementAt(numPere1),(GDroite) buf.elementAt(numPere2)); break;
             case Geom.BISSECTRICE2 :
                 return newBissectrice2((GPoint) buf.elementAt(numPere1),(GPoint) buf.elementAt(numPere2)); break;
             case Geom.MEDIATRICE :
                 return newIntersection((GPoint) buf.elementAt(numPere1),(GPoint) buf.elementAt(numPere2)); break;
             case Geom.TANGENTE :
                 return newTangente((GCourbe) buf.elementAt(numPere1)); break;
			 case Geom.NORMALE :
			     return newNormale((GCourbe) buf.elementAt(numPere1)); break;
			 case Geom.D_SYMETRIE_POINT:
			     return newSymetrique((GDroite) buf.elementAt(numPere1),(GPoint) buf.elementAt(numPere2)); break;
			 case Geom.D_SYMETRIE_DROITE:
			     return newSymetrique((GDroite) buf.elementAt(numPere1),(GDroite) buf.elementAt(numPere2)); break;
			 case Geom.AXE_RADICAL :
			     return newAxeRadical((GCercle) buf.elementAt(numPere1),(GCercle) buf.elementAt(numPere2)); break;
			 }
	
      }
      
      public GCercle readGCercle(int constr,int numPere1,int numPere2) throws IOException{
          double x,y,r;
          x=readDouble();
          y=readDouble();
          r=readDouble();
          switch(constr){
             case Geom.CERCLE_PAR_CENTRE : 
                 return newCercleParCentreEtPoint((GPoint) buf.elementAt(numPere1),(GPoint) buf.elementAt(numPere2)); break;
             case Geom.CERCLE_PAR_DIAMETRE : 
                 return newCercleParDiametre((GPoint) buf.elementAt(numPere1),(GPoint) buf.elementAt(numPere2)); break;
             case Geom.CERCLE_OSCULATEUR : 
                 return newCercleOsculateur((GCourbe) buf.elementAt(numPere1)); break;
             case Geom.BISSECTRICE1 : 
                 return newBissectrice1((GDroite) buf.elementAt(numPere1),(GDroite) buf.elementAt(numPere2)); break;
             case Geom.BISSECTRICE2 :
                 return newBissectrice2((GPoint) buf.elementAt(numPere1),(GPoint) buf.elementAt(numPere2)); break;
             case Geom.MEDIATRICE :
                 return newIntersection((GPoint) buf.elementAt(numPere1),(GPoint) buf.elementAt(numPere2)); break;
             case Geom.TANGENTE :
                 return newTangente((GCourbe) buf.elementAt(numPere1)); break;
			 case Geom.NORMALE :
			     return newNormale((GCourbe) buf.elementAt(numPere1)); break;
			 case Geom.C_SYMETRIE_POINT:
			     return newSymetrique((GCercle) buf.elementAt(numPere1),(GPoint) buf.elementAt(numPere2)); break;
			 case Geom.C_SYMETRIE_DROITE:
			     return newSymetrique((GCercle) buf.elementAt(numPere1),(GDroite) buf.elementAt(numPere2)); break;
			 } 
      }
      
    
      public GCourbe readGCourbe(int constr,int numPere1,int numPere2) throws IOException{
          double c,x,y,tMin,tMax,t0;
          int numPoints;
          Expression xExpr,yExpr;
          String fctX,fctY;
          x=readDouble();
          y=readDouble();
          tMin=readDouble();
          tMax=readDouble();
          t0=readDouble();
          numPoints=readInt();
          fctX=readString();
          fctY=readString();
          xExpr=anal.analyse(fctX);
          yExpr=anal.analyse(fctY);
          return new GCourbe(fctX,fctY,xExpr,yExpr,tMin,tMax,numPoints,t0);
       
      }
      
      public GEnsemble readGEnsemble(int constr,int numPere1,int numPere2) throws IOException{
          switch(constr){
             case Geom.LIEU : return newLieu((GPoint) buf.elementAt(numPere1),(GPoint) buf.elementAt(numPere2)); break;
             case Geom.ENVELOPPE : return newEnveloppe((GPoint) buf.elementAt(numPere1),(GDroite) buf.elementAt(numPere2)); break;
           }
      }
      
      
      public void readAllGeom(GeomObject obj) throws IOException{
           GeomObject courant=obj;
           while(courant != null){
               readGeom(obj);
               courant=courant.suivant;
           }
      }
}