import java.io.*;
import java.awt.*;

class GeomOutputStream extends DataOutputStream{
        
      GeomOutputStream(String s) throws IOException{
          super(new FileOutputStream(s));
      }
      
      public void writeString(String s) throws IOException{
          // writeInt(s.length());
          // writeChars(s);
          writeUTF(s);
      }
      
      private void writeGeneral(GeomObject m) throws IOException{
      	  writeInt(m.numero);
          writeInt(m.type);
          writeInt(m.constr);
          if(m.pere1!=null)
                {writeInt(m.pere1.numero);}
          else { writeInt(-1); }
          if(m.pere2!=null)
                {writeInt(m.pere2.numero);}
          else { writeInt(-1); }
          writeInt(m.couleur.getRGB());
          writeString(m.nom);
      }
      
      public void writeGPoint(GPoint m) throws IOException{
          writeGeneral(m);
          writeDouble(m.x);
          writeDouble(m.y);
          
      }
      
      public void writeGDroite(GDroite d) throws IOException{
          writeGeneral(d);
          writeDouble(d.u);
          writeDouble(d.v);
          writeDouble(d.h);
      }
      
      public void writeGCercle(GCercle c) throws IOException{
          writeGeneral(c);
          writeDouble(c.x);
          writeDouble(c.y);
          writeDouble(c.r);
      }
      
      public void writeGCourbe(GCourbe c) throws IOException{
          writeGeneral(c);
          writeDouble(c.x);
          writeDouble(c.y);
          writeDouble(c.tMin);
          writeDouble(c.tMax);
          writeDouble(c.t0);
          writeInt(c.numPoints);
          writeString(c.fctX);
          writeString(c.fctY);
      }
      
      public void writeGEnsemble(GEnsemble c) throws IOException{
          writeGeneral(c);
      }
      
      public void writeGeom(GeomObject obj) throws IOException{
          switch(obj.type){
             case Geom.POINT : writeGPoint((GPoint) obj); break;
             case Geom.DROITE : writeGDroite((GDroite) obj); break;
             case Geom.CERCLE : writeGCercle((GCercle) obj); break;
             case Geom.COURBE : writeGCourbe((GCourbe) obj); break;
             case Geom.ENSEMBLE : writeGEnsemble((GEnsemble) obj); break;
          }
      }
      
      
      public void writeAllGeom(GeomObject obj) throws IOException{
           GeomObject courant=obj;
           while(courant != null){
               writeGeom(obj);
               courant=courant.suivant;
           }
      }
}