import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.io.*;
import java.util.*;
import java.lang.Math;


public class Surface extends Applet implements AdjustmentListener,ActionListener,ItemListener{
  SurfaceCanvas c ;
  Scrollbar latScroll1,longScroll1,latScroll2,longScroll2;
  Panel pan1,pan2;
  TextField xText,yText,zText,uMinText,uMaxText,vMinText,vMaxText,nbUText,nbVText,zoomText;
  Label xLabel,yLabel,zLabel;
  Button traceButton;
  Choice typeChoice;
  
  
  
  
    
     public void init() {
	 setLayout(new KappaLayout());
	 
	 add(xLabel = new Label("x="),"0, 0, , ,3 ,w , ");
	 xText=new TextField("u",20);
	 add(xText,"1,0, , ,7 , , ");
	 add(yLabel = new Label("y="),"2,0, , , 3,w , ");
	 yText=new TextField("v",20);
	 add(yText,"3,0, , , 7, , ");
	 add(zLabel = new Label("z="),"4,0, , ,3 ,w , ");
	 zText=new TextField("u^2-v^2",20);
	 add(zText,"5,0, , ,7 , , ");
	 
	 add(new Label("uMin = "),"0,1, , ,3 , , ");
	 uMinText=new TextField("-2",6);
	 add(uMinText,"1,1, , ,7 , , ");
	 add(new Label("uMax = "),"2,1, , ,3 , , ");
	 uMaxText=new TextField("2",6);
	 add(uMaxText,"3,1, , ,7 , , ");
	 add(new Label("nb pts u = "),"4,1, , ,3 , , ");
	 nbUText=new TextField("20",4);
	 add(nbUText,"5,1, , ,7 , , ");
	 add(new Label("vMin = "),"0,2, , ,3 , , ");
	 vMinText = new TextField("-2",6);
	 add(vMinText,"1,2, , ,7 , , ");
	 add(new Label("vMax = "),"2,2, , ,3 , , ");
	 vMaxText=new TextField("2",6);
	 add(vMaxText,"3,2, , ,7 , , ");
	 add(new Label("nb pts v = "),"4,2, , ,3 , , ");
	 nbVText=new TextField("20",4);
	 add(nbVText,"5,2, , ,7 , , ");
	 traceButton=new Button("tracer");
	 add(traceButton,"1,3, , , , hw , ");
	 traceButton.addActionListener(this);
	 typeChoice=new Choice();
	 typeChoice.add("cartesiennes");
	 typeChoice.add("cylindriques");
	 typeChoice.add("spheriques");
    	 add(typeChoice,"3,3, , , , hw , ");
	 typeChoice.addItemListener(this);
	 typeChoice.select(0);
	 add(new Label("zoom="),"4,3, , ,3 , , ");
	 zoomText=new TextField((new Double(1)).toString(),4);
	 add(zoomText,"5,3, , ,7 , , ");
	 
	 
	 add(KappaLayout.createVerticalStrut(400),"0 , 4 , , , , , ");
	 pan2=new Panel(new BorderLayout());
	 add(pan2,"1 , 4 , 6 , 6 , 8 , hw , ");
	 c = new SurfaceCanvas(20,20);
	 pan2.add(c,"Center");
	 longScroll1 = new Scrollbar(Scrollbar.HORIZONTAL,1,35,-180,180);
         pan2.add("South", longScroll1);
	 longScroll2 = new Scrollbar(Scrollbar.HORIZONTAL,1,35,-180,180);
         pan2.add("North", longScroll2);
	 longScroll1.setValue(35);
	 longScroll2.setValue(35);
	 longScroll1.addAdjustmentListener(this);
         longScroll2.addAdjustmentListener(this);
        
         latScroll1 = new Scrollbar(Scrollbar.VERTICAL,1,-25,-90,90); 
         pan2.add("East", latScroll1);
	 latScroll2 = new Scrollbar(Scrollbar.VERTICAL,1,-25,-90,90); 
         pan2.add("West", latScroll2);
	 latScroll1.setValue(-25);
	 latScroll2.setValue(-25);
	 latScroll1.addAdjustmentListener(this);
         latScroll2.addAdjustmentListener(this);
	}
	
     public void adjustmentValueChanged(AdjustmentEvent e){
                        if(e.getAdjustable() == latScroll1){
                                latScroll1.setValue(latScroll1.getValue());
				latScroll2.setValue(latScroll1.getValue());
                                c.setLongLat(longScroll1.getValue(),-latScroll1.getValue());
                        }
			if(e.getAdjustable() == latScroll2){
                                latScroll1.setValue(latScroll2.getValue());
				latScroll2.setValue(latScroll2.getValue());
                                c.setLongLat(longScroll1.getValue(),-latScroll1.getValue());
                        }
                        if(e.getAdjustable() == longScroll1){
                                longScroll1.setValue(longScroll1.getValue());
				longScroll2.setValue(longScroll1.getValue());
                                c.setLongLat(longScroll1.getValue(),-latScroll1.getValue());
                        }
			if(e.getAdjustable() == longScroll2){
                                longScroll1.setValue(longScroll2.getValue());
				longScroll2.setValue(longScroll2.getValue());
                                c.setLongLat(longScroll1.getValue(),-latScroll1.getValue());
                        }
     }
     
     public void actionPerformed(ActionEvent event){
	 double uMin,uMax,vMin,vMax,zoom;
	 int nbU,nbV;
	    try {
		    nbU=Integer.parseInt(nbUText.getText());
		    uMin=(Double.valueOf(uMinText.getText())).doubleValue();
		    uMax=(Double.valueOf(uMaxText.getText())).doubleValue();
		    nbV=Integer.parseInt(nbVText.getText());
		    vMin=(Double.valueOf(vMinText.getText())).doubleValue();
		    vMax=(Double.valueOf(vMaxText.getText())).doubleValue();
		    zoom=(Double.valueOf(zoomText.getText())).doubleValue();
		}
		catch(NumberFormatException erreur) {
			nbU=nbV=20;
			uMin=vMin=-2;
			uMax=vMax=2;
			zoom=1;
		}
		c.entreParams(uMin,uMax,nbU,vMin,vMax,nbV,xText.getText(),yText.getText(),zText.getText(),zoom);
        }
	
	public void itemStateChanged(ItemEvent e) {
              if(e.getItemSelectable()== typeChoice) {
              	String s=((Choice) e.getItemSelectable()).getSelectedItem();
              	if(s.equals("cartesiennes")) {
              		c.setType(SurfaceCanvas.CARTESIENNE);
			xLabel.setText("x=");
			yLabel.setText("y=");
			zLabel.setText("z=");		
					
              	}
		if(s.equals("cylindriques")) {
              		c.setType(SurfaceCanvas.CYLINDRIQUE);
			xLabel.setText("rho=");
			yLabel.setText("theta=");
			zLabel.setText("z=");
              	}
		if(s.equals("spheriques")) {
			c.setType(SurfaceCanvas.SPHERIQUE);
			xLabel.setText("rho=");
			yLabel.setText("theta=");
			zLabel.setText("phi=");
		}
				
              }
			  
	}
	

}


class SurfaceCanvas extends Canvas {
    static final double DEG2RAD=Math.PI/180;
    static final int CARTESIENNE=0, CYLINDRIQUE=1, SPHERIQUE=2;
    
    
	   private class Repere {
		double xi,yi,xj,yj,zj,xk,yk,zk;
		
		Repere() {
		    xi=1;
		    yi=0;
		    xj=0;
		    yj=1;
		    zj=0;
		    xk=0;
		    yk=0;
		    zk=1;
		}
		
		Repere(double theta,double phi) {
		    theta=theta*DEG2RAD;
		    phi=phi*DEG2RAD;
		    double vuex=Math.cos(theta)*Math.cos(phi);
		    double vuey=Math.sin(theta)*Math.cos(phi);
		    double vuez=Math.sin(phi);
		    double d1=Math.sqrt(1-vuez*vuez);
		    if(d1<1e-4) {
			xi=1;
			yi=0;
			xj=0;
			yj=1;
			zj=0;
			xk=0;
			yk=0;
			zk= vuez>0 ? 1 : -1;
		    } else {
			xi = -vuey/d1;
			yi = vuex/d1;
			xj = -(vuex*vuez)/d1;
			yj = -(vuey*vuez)/d1;
			zj = d1;
			xk = yi*zj;
			yk = -xi*zj;
			zk = xi*yj -xj*yi;
		    }
		}
		
		void modifie(double theta,double phi) {
		    theta=theta*DEG2RAD;
		    phi=phi*DEG2RAD;
		    double vuex=Math.cos(theta)*Math.cos(phi);
		    double vuey=Math.sin(theta)*Math.cos(phi);
		    double vuez=Math.sin(phi);
		    double d1=Math.sqrt(1-vuez*vuez);
		    if(d1<1e-3) {
			xi=1;
			yi=0;
			xj=0;
			yj=1;
			zj=0;
			xk=0;
			yk=0;
			zk=1;
		    } else {
			xi = -vuey/d1;
			yi = vuex/d1;
			xj = -(vuex*vuez)/d1;
			yj = -(vuey*vuez)/d1;
			zj = d1;
			xk = yi*zj;
			yk = -xi*zj;
			zk = xi*yj -xj*yi;
		    }
		}
		
	    }

		

	    private class Point2D {
		double x,y;
		
		Point2D(double x,double y) {
		    this.x=x;
		    this.y=y;
		}
	    }

	    private class Point3D {
		double x,y,z;
		
		Point3D(double x,double y,double z) {
		    this.x=x;
		    this.y=y;
		    this.z=z;
		}
		
		Point2D projetteXY(Repere rep) {
		    double x1=x*rep.xi+y*rep.yi;
		    double y1=x*rep.xj+y*rep.yj+z*rep.zj;
		    return new Point2D(x1,y1);
		}
		
		long projetteZ(Repere rep) {
		    return (long) (1000*(x*rep.xk+y*rep.yk+z*rep.zk));
		}
	    }

	    private class Profondeur {
		int i,j;
		long z;
		
		Profondeur(int i,int j, long z) {
		    this.i=i;
		    this.j=j;
		    this.z=z;
		}
		
		public String toString() {
		    return i+" "+j+" z="+z;
		}
		
	    }
	    

    
    // champs de SurfaceCanvas
    int nbPtsU, nbPtsV;
    Point3D[][] lesSommets;
    Point2D[][] lesPolys;
    Profondeur[] lesProfondeurs;
    int[][] xEcran,yEcran;
    double xMin=-3,xMax=3,yMin=-3,yMax=3;
    double uMin=-2,uMax=2,vMin=-2,vMax=2;
    Repere repere;
    int maxHor=300, maxVer=300;
    String fctX,fctY,fctZ;
    Analyseur anal;
    int type=CARTESIENNE;
    
    
    
    SurfaceCanvas() {
	super();
	construitSommets();
	construitPolys();
	heapsort();
    }
    
    SurfaceCanvas(int nbPtsU,int nbPtsV) {
	// super();
	this.nbPtsU=nbPtsU;
	this.nbPtsV=nbPtsV;
	lesSommets=new Point3D[nbPtsU][nbPtsV];
	lesPolys=new Point2D[nbPtsU][nbPtsV];
	lesProfondeurs=new Profondeur[nbPtsU*nbPtsV+1];
	xEcran=new int [nbPtsU][nbPtsV];
	yEcran=new int [nbPtsU][nbPtsV];
	repere=new Repere(35,25);
	fctX="u";
	fctY="v";
	fctZ="(u^2-v^2)/3";
	anal=new Analyseur();
	construitSommets();
	construitPolys();
	heapsort();
    }
    
    
    void construitSommets() {
	Expression xExpr=Expression.nouvelleExpression(0),
	           yExpr=Expression.nouvelleExpression(0),
		   zExpr=Expression.nouvelleExpression(0);
	double u,v,x,y,z,rho,theta,phi;
	double uPas=(uMax-uMin)/(nbPtsU-1), vPas=(vMax-vMin)/(nbPtsV-1);
	int i,j;
	
	try {
		xExpr=anal.analyse(fctX); 
		yExpr=anal.analyse(fctY); 
		zExpr=anal.analyse(fctZ);
	} catch (IOException e) {
		System.err.print("Syntaxe incorrecte");
		System.exit(1);
	}
	switch(type) {
	    case CARTESIENNE:
		for(i=0,u=uMin; i<nbPtsU;i++,u+=uPas) {
		    for(j=0,v=vMin; j<nbPtsV;j++,v+=vPas) {
			x=xExpr.evalue("u",u,"v",v);
			y=yExpr.evalue("u",u,"v",v);
			z=zExpr.evalue("u",u,"v",v);
			lesSommets[i][j]=new Point3D(x,y,z);
		    }
		}
		break;
	   case CYLINDRIQUE:
	        for(i=0,u=uMin; i<nbPtsU;i++,u+=uPas) {
		    for(j=0,v=vMin; j<nbPtsV;j++,v+=vPas) {
			rho=xExpr.evalue("u",u,"v",v);
			theta=yExpr.evalue("u",u,"v",v);
			z=zExpr.evalue("u",u,"v",v);
			lesSommets[i][j]=new Point3D(rho*Math.cos(theta),rho*Math.sin(theta),z);
		    }
		}
		break;
	   case SPHERIQUE:
	     for(i=0,u=uMin; i<nbPtsU;i++,u+=uPas) {
		    for(j=0,v=vMin; j<nbPtsV;j++,v+=vPas) {
			rho=xExpr.evalue("u",u,"v",v);
			theta=yExpr.evalue("u",u,"v",v);
			phi=zExpr.evalue("u",u,"v",v);
			lesSommets[i][j]=new Point3D(rho*Math.cos(theta)*Math.cos(phi),rho*Math.sin(theta)*Math.cos(phi),Math.sin(phi));
		    }
		}
		break;
	}
    }
    
    void construitPolys() {
        for(int i=0; i<nbPtsU;i++) {
            for(int j=0; j<nbPtsV;j++) {
                lesPolys[i][j]=lesSommets[i][j].projetteXY(repere);
                lesProfondeurs[i+nbPtsU*j+1]=new Profondeur(i,j,lesSommets[i][j].projetteZ(repere));
            }
        }
    }
    
    int xEcran(double x,double xDebut,double xFin) {
		return (int) ((x-xDebut)/(xFin-xDebut)*maxHor);
	}
	
    int yEcran(double y,double yDebut,double yFin) {
		return (int) ((yFin-y)/(yFin-yDebut)*maxVer);
	}
    
    void construitEcran() {
        for(int i=0; i<nbPtsU;i++) {
            for(int j=0; j<nbPtsV;j++) {
                xEcran[i][j]=xEcran(lesPolys[i][j].x,xMin,xMax);
                yEcran[i][j]=yEcran(lesPolys[i][j].y,yMin,yMax);
            }
        }
    }
    
    void downheap(int k,int N) { // cf Sedgewick
        int j;
        Profondeur v;
        v=lesProfondeurs[k];
	while(k<=N/2) {
	    j=k+k;
	    if(j<N)if(lesProfondeurs[j].z<lesProfondeurs[j+1].z) j++;
	    if(v.z>=lesProfondeurs[j].z) break;
	    lesProfondeurs[k]=lesProfondeurs[j];
	    k=j;
	}
	lesProfondeurs[k]=v;
    }
    
   void heapsort() { // cf Sedgewick
        int k,N=nbPtsU*nbPtsV;
        for(k=N/2; k>=1; k--) {
            downheap(k,N);
        }
        while(N>1) {
            Profondeur temp=lesProfondeurs[1];
            lesProfondeurs[1]=lesProfondeurs[N];
            lesProfondeurs[N]=temp;
            downheap(1,--N);
        }
    }
    
    public void setLongLat(int lon, int lat) {
        repere.modifie(lon,lat);
	construitPolys();
	heapsort();
	repaint();
    }
    
    public void entreFonctions(String x, String y, String z) {
        fctX=x;
        fctY=y;
        fctZ=z;
        construitSommets();
	construitPolys();
	heapsort();
	repaint();
    }
			  
    public void setZoom(double zoom) {
        yMin=xMin=-3/zoom;
        yMax=xMax=3/zoom;
	repaint();
    }
    
    
    public void entreParams(double u0,double u1,int nu,double v0, double v1, int nv, String x, String y, String z,double zoom) {
        if((nu!=nbPtsU) || (nv!=nbPtsV)) {
            nbPtsU=nu;
            nbPtsV=nv;
            lesSommets=new Point3D[nbPtsU][nbPtsV];
	    lesPolys=new Point2D[nbPtsU][nbPtsV];
	    lesProfondeurs=new Profondeur[nbPtsU*nbPtsV+1];
            xEcran=new int [nbPtsU][nbPtsV];
            yEcran=new int [nbPtsU][nbPtsV];
        }
        uMin=u0;
        uMax=u1;
        vMin=v0;
        vMax=v1;
        fctX=x;
        fctY=y;
        fctZ=z;
	yMin=xMin=-3/zoom;
        yMax=xMax=3/zoom;
        construitSommets();
	construitPolys();
	heapsort();
	repaint();
    }
    
    public void setType(int type) {
        this.type=type;
    }
    
    public void paint(Graphics g) {
	int [] xx=new int[4];
	int [] yy=new int[4];
	int x0,x1,x2,y0,y1,y2;
	int i,j;
	
	Rectangle r = getBounds();
	maxVer = r.height;
	maxHor = r.width;
	construitEcran();
        for(int k=1; k<=nbPtsU*nbPtsV;k++) {
	      i=lesProfondeurs[k].i;
	      j=lesProfondeurs[k].j;
	      if((i<nbPtsU-1) && (j<nbPtsV-1)) {
	          xx[0] = x0 = xEcran[i][j];
		  xx[1] = x1 = xEcran[i][j+1];
		  xx[2] = x2 = xEcran[i+1][j+1];
		  xx[3] = xEcran[i+1][j];
		  yy[0] = y0 = yEcran[i][j];
		  yy[1] = y1 = yEcran[i][j+1];
		  yy[2] = y2 = yEcran[i+1][j+1];
		  yy[3] = yEcran[i+1][j];
		  if((x1-x0)*(y2-y0)-(y1-y0)*(x2-x0)>0)
		      g.setColor(Color.green);
	          else g.setColor(Color.blue);
		  g.fillPolygon(xx,yy,4);
		  g.setColor(Color.red);
		  g.drawPolygon(xx,yy,4);
	      }
	      
	     
	}
    }
}


