class IntNode {
	IntNode  gauche,droite;
	int etiquette;
	
	IntNode(int x,IntNode gauche, IntNode droite){
	     etiquette = x;
	     this.gauche=gauche;
	     this.droite=droite;
	}
	
	IntNode(int x){
	     etiquette=x;
	     gauche=null;
	     droite=null;
	}
	
	public void toString(){
	     if(gauche==null){
	         if(droite==null) return ""+etiquette;
	         else return "("+etiquette+",(  ,"+droite.toString()+"))";
	     } else {
	         if(droite==null) return "("+etiquette+",("+gauche.toString()+",  ))";
	         else return "("+etiquette+",("+gauche.toString()+","+droite.toString()+"))";
	     }
	}
}

class TreeAnalyzer{
	StringReader flux;
	StreamTokenizer lex;
	
	IntNode analyse(String s) throws IOException {
		flux = new StringReader(s);
		lex = new StreamTokenizer(flux);
		lex.ordinaryChar(',');
		lex.ordinaryChar('(');
		lex.ordinaryChar(')');
		return analyseNoeud();
    }
    
    IntNode analyseNoeud() throws IOException {
        int c=lex.nextToken();
        switch(c){
           case StreamTokenizer.TT_NUMBER:
                return new IntNode(lex.nval);
           case '(':
                c=lex.nextToken();
                if(c!=StreamTokenizer.TT_NUMBER) throw new IOException("format invalide");
                int x = lex.nval;
                c=lex.nextToken();
                if(c!=',') throw new IOException("format invalide");
                c=lex.nextToken();
                if(c!='(') throw new IOException("format invalide");
                IntNode gauche = analyseNoeud();
                c=lex.nextToken();
                if(c!=',') throw new IOException("format invalide");
                IntNode droite = analyseNoeud();
                c=lex.nextToken();
                if(c!=')') throw new IOException("format invalide");
                return new IntNode(x,gauche,droite);
            default :
                lex.pushBack();
                return null;
         }
      }
                
}

class BinaryTree {
     IntNode racine;
     
     BinaryTree() {
        racine=null;
     }
         
     
     BinaryTree(String s){
         TreeAnalyzer analyseur= new TreeAnalyzer();
         racine = analyseur.analyse(s);
     }
     
     public boolean estVide(){
        return (racine==null);
     }
}

class BinarySearchTree extends BinaryTree {
     
     private boolean cherche(int x, IntNode noeud){
         if(noeud==null) return false;
         if(x==noeud.etiquette) return true; 
         else if(x>noeud.etiquette) return cherche(x,noeud.droite);
         else return cherche(x,noeud.droite);
     }
     public boolean contient(int x) {
         return cherche(x,racine);
     }
     private void insereNoeud(int x, IntNode noeud){
          if(noeud==null){
                noeud = new IntNode(x,null,null);
          } else if(x>noeud.etiquette) insereNoeud(x,noeud.droite));
          else insereNoeud(x,noeud.gauche);
	}
	public void insere(int x){
	      insereNoeud(x,racine);
	}
	private int cherchePlusADroite(IntNode noeud){
	      if(noeud.droite==null){
	           int x = noeud.etiquette;
	           noeud = noeud.gauche;
	           return x;
	      } else return cherchePlusAdroite(noeud.droite);
	 }
	private void supprimeRacineNoeud(IntNode noeud){
	      if(noeud!=null){
		      if(noeud.gauche==null) noeud=noeud.droite;
		      else if(noeud.droite==null) noeud=noeud.gauche;
		      else  noeud.etiquette=cherchePlusADroite(noeud.gauche);
	      }
	 }
	private void supprimeNoeud(int x,IntNode noeud){
	      if(noeud!=null){
	      	if(x==noeud.etiquette) supprimeRacineNoeud(noeud);
	      	else if(x>noeud.etiquette) supprime(x,noeud.droite)
	      	else supprime(x,noeud.gauche);
	      }
	 }
	public void supprime(int x){
	       supprimeNoeud(x,racine);
	 }
}

class PriorityTree extends BinaryTree{
	
	private void insereNoeud(int x,IntNode noeud){
	      if(noeud==null){
	          noeud = new IntNode(x,null,null);
	      } else if(x<=noeud.etiquette) insereNoeud(x,noeud.gauche)
	      else {
	          insereNoeud(noeud.etiquette,noeud.droite;
	          noeud.etiquette=x;
	      }
	 }
	 public void insere(int x){
	       insereNoeud(x,racine);
	 }
	 private int terminalNoeud(IntNode noeud){
	       if(noeud.droite!=null) return terminalNoeud(noeud.droite);
	       if(noeud.gauche!=null) return terminalNoeud(noeud.gauche);
	       int x=noeud.etiquette;
	       noeud=null;
	       return x;
	 }
	 private void percoleNoeud(IntNode noeud){
	       int xg,xd;
	       if((noeud.droite!=null) && (noeud.gauche!=null)){
	           xg=noeud.gauche.etiquette;
	           xd=noeud.droite.etiquette;
	           if((xg>=xd) && (xg>noeud.etiquette)){
	               noeud.gauche.etiquette=noeud.etiquette;
	               noeud.etiquette=xg;
	               percoleNoeud(noeud.gauche);
	            } else if((xd>xg) && (xd>noeud.etiquette)){
	               noeud.droite.etiquette=noeud.etiquette;
	               noeud.etiquette=xd;
	               percoleNoeud(noeud.droite);
	            }
	        } else if(noeud.droite!=null){
	           xd=noeud.droite.etiquette;
	           if(xd>noeud.etiquette){
	               noeud.droite.etiquette=noeud.etiquette;
	               noeud.etiquette=xd;
	               percoleNoeud(noeud.droite);
	            }
	         else if(noeud.gauche!=null){
	            xg=noeud.gauche.etiquette;
	            if(xg>noeud.etiquette){
	               int xg=noeud.gauche.etiquette;
	               noeud.gauche.etiquette=noeud.etiquette;
	               noeud.etiquette=xg;
	               percoleNoeud(noeud.gauche);
	            }
	              
	 }
	 public int sortMax(){
	        int x=racine.etiquette;
	        int y=terminalNoeud(racine);
	        racine.etiquette=y;
	        percoleNoeud(racine);
	        return x;
	 }
	 
	          