import java.util.*;
import java.io.*;
import java.io.StreamTokenizer;


public class Analyseur {
	StringReader flux;
	StreamTokenizer lex;
	    
    Expression analyse(String s) throws IOException {
	flux = new StringReader(s);
	lex = new StreamTokenizer(flux);
	lex.ordinaryChar('+');
	lex.ordinaryChar('-');
	lex.ordinaryChar('*');
	lex.ordinaryChar('/');
	lex.ordinaryChar('^');
	lex.ordinaryChar('(');
	lex.ordinaryChar(')');
	return analyseExpression();
    }
    
    // expression := terme expressionDroite
    Expression analyseExpression() throws IOException{
        return analyseExpressionDroite(analyseTerme());
    }
    
    // expressionDroite := + terme expressionDroite | - terme expression droite | VIDE
    Expression analyseExpressionDroite(Expression arbre_g) throws IOException{
	Expression arbre_d;
        int c=lex.nextToken(); 
	switch(c) { 
	    case '+': 
		arbre_d=analyseTerme();
		return analyseExpressionDroite(Expression.nouvelleExpression("+",arbre_g,arbre_d));
	    case '-': 
		arbre_d=analyseTerme();
		return analyseExpressionDroite(Expression.nouvelleExpression("-",arbre_g,arbre_d));
	   default:
		 lex.pushBack();
		 return arbre_g;
	}
    }
    
    // terme := puissance termeDroite
    Expression analyseTerme() throws IOException{
        return analyseTermeDroite(analysePuissance());
    }
    
    // termeDroite := * puissance termeDroite | / puissance termeDroite | VIDE
    Expression analyseTermeDroite(Expression arbre_g) throws IOException{
	Expression arbre_d;
        int c=lex.nextToken();
	switch(c) {
	    case '*': 
		arbre_d=analysePuissance();
		return analyseTermeDroite(Expression.nouvelleExpression("*",arbre_g,arbre_d));
	    case '/': 
		arbre_d=analysePuissance();
		return analyseTermeDroite(Expression.nouvelleExpression("/",arbre_g,arbre_d));
	   default:
	     lex.pushBack();
	     return arbre_g;
	}
    }
    
    // puissance := facteur puissanceDroite
    Expression analysePuissance() throws IOException{
        return analysePuissanceDroite(analyseFacteur());
    }
    
    //  puissanceDroite := ^ facteur puissanceDroite | Vide
    Expression analysePuissanceDroite(Expression arbre_g) throws IOException{
        int c=lex.nextToken();
	if(c=='^') {
	    Expression arbre_d=analyseFacteur();
	    return analysePuissanceDroite(Expression.nouvelleExpression("^",arbre_g,arbre_d));
	} else {
	   lex.pushBack();
	   return arbre_g;
	   
	}
    }
    
    // facteur := ( expression ) | - facteur | fonction ( expression ) | variable | nombre 
    Expression analyseFacteur() throws IOException{
	Expression arbre;
	int c1;
        int c=lex.nextToken();
	switch(c) {
	    case '(':  // expression parenthse
                arbre = analyseExpression();
                c1 = lex.nextToken();
	        if(c1==')') {
	            return arbre;
	        } else return Expression.nouvelleExpression(0);   
            case '-': // moins unaire
		arbre = analyseFacteur();
		return Expression.nouvelleExpression("-",arbre);
	    case StreamTokenizer.TT_WORD: // commence par un nom
		String nom=lex.sval;
		c1=lex.nextToken();
		if(c1=='(') { // c'est une fonction
		    arbre=analyseExpression();
		    int c2=lex.nextToken();
		    if(c2==')') {
			return Expression.nouvelleExpression(nom,arbre);
		    } else return Expression.nouvelleExpression(0);
		} 
		else { // c'est une variable
		    lex.pushBack();
		    return Expression.nouvelleExpression(nom);
		}
	   case StreamTokenizer.TT_NUMBER: // un nombre
		return Expression.nouvelleExpression(lex.nval);
	   default: return Expression.nouvelleExpression(0);
	}
    }
    
}
